#!/usr/bin/perl
# cgi-irc v0.4.2 - http://cgiirc.sourceforge.net/
# (C) 2000-2001 David Leadbeater (cgiirc@dgl.cx)
# cgi-irc comes with ABSOLUTELY NO WARRANTY
# This is free software, and you are welcome to redistribute it
# under certain conditions; read the file COPYING for details

use strict;
my $version="0.4.2";
use vars qw/%config/;
use vars qw/$sock/;
use IO::Socket;
use CGI;
my $q = new CGI;

$config{file}="config";
&config($config{file});

my $name = $ENV{SCRIPT_NAME};

if(!defined $config{kill_password} || !$config{kill_password}){
   print $q->header();
   htmlheader();
   print "Admin interface must be enabled";
   htmlend();
   exit;
}elsif($q->cookie('adminid') and crypt($config{kill_password},substr($q->cookie('adminid'),0,2)) eq $q->cookie('adminid')){
   print $q->header();
   &htmlheader;
}elsif($q->param('login') && crypt($q->param('login'),substr($config{kill_password},0,2)) eq $config{kill_password}){
   my $cookie = $q->cookie(-name=>'adminid',
	  -value=>crypt($config{kill_password},join "", (0..9, "A".."Z", "a".."z","/")[rand 64, rand 64]));
   print $q->header(-cookie=>$cookie);
   htmlheader();
}else{
   print $q->header();
   htmlheader();
   print "<form method=\"post\" action=\"$name\"><label>Login:</label><input type=\"password\" name=\"login\"><input type=\"submit\" value=\"Login\"></form>\n";
   htmlend();
   exit;
}

if(!defined $q->param('action')){
   &list_u();
}elsif($q->param('action') eq "kick"){
   if(defined $q->param('u')){
	  connect_u($q->param('u'));
      kick_u();
	  print "<b>Kicked User</b><br><br>\n";
	  list_u();
   }
}elsif($q->param('action') eq "message"){
   if(!$q->param('t')){
	  print "<form method=\"post\" action=\"$name\"><input type=\"hidden\" name=\"action\" value=\"message\"><input type=\"hidden\" name=\"u\" value=\"".$q->param('u')."\">Text: <input type=\"text\" name=\"t\"></form>\n";
   }else{
	  if($q->param('u') eq 'all'){
		 $config{tmpfile_prefix} =~ /^(.*)\/([^\/]*)$/;
		 my ($dir,$prefix)=($1,$2);
		 opendir(TMP, $dir);
		 while($_ = readdir(TMP)) {
			next if $_ !~ s/^\Q$prefix\E//;
			connect_u($_);
			next if !defined $sock;
			print $sock "/ADMINMESSAGE ".$q->param('t')."\n";
		 }
		 closedir(TMP);
		 print "<b>Messaged all users</B><br><br>\n";
	  }else{
		 connect_u($q->param('u'));
		 exit if !$sock;
		 print $sock "/ADMINMESSAGE ".$q->param('t')."\n";
		 print "<b>Messaged user</b><br><br>\n";
	  }
	  &list_u;
   }
}
&htmlend;
exit;

sub connect_u{
   my $random=shift;
   return if $random =~ /[^A-Za-z0-9]/;
   $sock = IO::Socket::UNIX->new(
      Peer => "$config{tmpfile_prefix}$random") or print "Couldn't connect to $random: $!\n";
}

sub list_u{
   $config{tmpfile_prefix} =~ /^(.*)\/([^\/]*)$/;
   my ($dir,$prefix)=($1,$2);
   opendir(TMP, $dir);
   while($_ = readdir(TMP)) {
	  next if $_ !~ s/^\Q$prefix\E//;
	  connect_u($_);
	  next if !defined $sock;
	  my($channels,$default_channel,$nick,$server) = status_u();
	  my($ip) = ip_u();
	  print "$ip - ".escapehtml($nick)." - ".escapehtml($server)." - ".escapehtml($channels)." [<a href='$name?action=message&u=$_'>Message</a> | <a href='$name?action=kick&u=$_'>Kick</a> ]<br>\n";
	  close_u();
   }
   print "<a href='$name?action=message&u=all'>Message All</a><br>\n";
   closedir(TMP);
}

sub status_u{
   print $sock "/STATUS\n";
   my($c,$d,$n,$s);
   $c=<$sock>;
   $d=<$sock>;
   $n=<$sock>;
   $s=<$sock>;
   chomp($c,$d,$n,$s);
   return($c,$d,$n,$s);
}

sub ip_u{
   print $sock "/UCREMOTEIP\n";
   my($d);
   $d=<$sock>;
   chomp($d);
   return $d;
}

sub kick_u{
   print $sock "/QUIT Admin Kick\n";
   close_u();
}

sub send_u{
   my $send=shift;
   print $sock $send,"\n";
}

sub close_u{
   print $sock "/CLOSESOCKET\n";
   close($sock);
}

sub escapehtml{
   my $tmp=shift;
   $tmp =~ s/</&lt;/g;
   $tmp =~ s/>/&gt;/g;
   $tmp =~ s/"/&quot;/g;
   return $tmp;
}

sub config{
   my $file=shift;
   my $section;
   # I wonder how you are 'supposed' to do this?
   no strict "refs";
   open(CONFIG, $file) or error("Unable to open config file");
   while(<CONFIG>){
	  s/(\015\012|\012)$//;
      next if /^(#|;)/;
      next if $_ !~ /^\S/;
      if(/^\[(\w+)\]$/){
         my $tmp=$1;
         $section= \%$tmp;
      }else{
         my($key,$value)=split(/=/,$_,2);
         $$section{$key}=$value;
      }
   }
   close(CONFIG);

}


sub htmlheader{
   print "<html><head><title>CGI:IRC Admin</title></head><body bgcolor=\"#ffffff\" fgcolor=\"#000000\"><h2>CGI:IRC Admin</h2>\n";
}

sub htmlend{
   print "</body></html>\n";
}

sub error{
   print "Content-type: text/plain\n\nError: $_[0]\n";
   exit;
}

