#!/usr/bin/perl
# cgi-irc v0.4.2 - http://cgiirc.sourceforge.net/
# (C) 2000-2001 David Leadbeater (cgiirc@dgl.cx)
# cgi-irc comes with ABSOLUTELY NO WARRANTY
# This is free software, and you are welcome to redistribute it
# under certain conditions; read the file COPYING for details

# This deals with the bottom frame, it takes the input and output over the
# unix-domain socket and prints a nice form for the user

use strict;
my $version="0.4.2";
use vars qw/%colours %formats %messages %symbols/;
use vars qw/%config %irc/;
use vars qw/$channel $say $rand $sock $default_channel $type $mode/;
use IO::Socket;
use CGI;
my $q = new CGI;
print "Cache-Control: no-cache\nExpires: -1\nPragma: no-cache\nContent-type: text/html\n\n";

# Change this if you change the location of the config file
$config{file}="config";

config($config{file});
loadformat();

$rand=$q->param('r');
$rand=~ s/[^a-z,0-9]//g;
$type=$q->param('action');
$channel=$q->param('c');
$channel =~ s/\n//g;
$default_channel = $q->param('chan-default');
$mode = $q->param('m');
$config{js} = $q->param('js');
if(!$config{js}){
   $config{hiddenform} = 0;
}

#### Start action

   $say=$q->param('say');
   $say =~ s/\n//g;
   &connect_u($rand);
   ($config{channels},$default_channel,$config{nick},$config{server})=status_u();
$channel ||= $default_channel;

   $config{topic} = topic_u($channel);
   if($channel ne $default_channel && $channel ne "No channel"){
	  &send_u("/chan $channel");
   }

   if($say){
	  &send_u($say);
   }
   &close_u;
if($type eq "hidden"){
   print "<html><body onLoad=\"parent.form.document.myform.say.value='';parent.form.document.myform.say.focus()\"></body></html>\n";
}else{
   &print_form($channel);
}

#### end action

exit;

#####################

sub print_form{
   my $channel=shift;
   my $escaped_channel=escapehtml($channel);
   my $escaped_topic=stripcrap(escapehtml($config{topic}));
   &{$messages{'form'}}($channel,$escaped_channel,$escaped_topic);
}

sub error{
   my $error=shift;
   if($q->param('first') eq 11 and ($error eq "Connection refused" || $error eq "No such file or directory")){
	  print "<html><head><meta
http-equiv=\"Refresh\" content=\"5;URL=$config{irc_form}?r=$rand\&first=11\&anticache=".rand()."\"><body
bgcolor=\"#ffffff\" text=\"#000000\">Loading...<br> Please wait</body></html>\n";
   }elsif($error eq "Connection refused" || $error eq "No such file or directory"){
	  print "<html><head><noscript>
		 <meta http-equiv=\"Refresh\" content=\"5;URL=$config{irc_form}?r=$rand\&anticache=".rand()."\">
		 </noscript></head><body bgcolor=\"#ffffff\" text=\"#000000\">
		 <a href=\"irc.cgi\" target=\"_top\">Login again?</a></body></html>";
   }else{
	  print "$error\n";
	  print_form();
   }
   exit;
}

sub printchannels{
   my $channel = shift;
   foreach my $split(split(/ /,$config{channels})){
      next if $split eq "";
      my $default;
      if($channel eq $split){$default=" SELECTED";}
      print "<option name=\"".escapehtml($split)."\"$default>".escapehtml($split)."</option>";
   }
    unless( $config{channels} ){
	   print "<option>No channel</option>";
	}
}

sub connect_u{
   my $random=shift;
   $sock = IO::Socket::UNIX->new(
      Peer => "$config{tmpfile_prefix}$random") or error($!);
}

sub status_u{
   print $sock "/STATUS\n";
   my($c,$d,$n,$s);
   $c=<$sock>;
   $d=<$sock>;
   $n=<$sock>;
   $s=<$sock>;
   chomp($c,$d,$n,$s);
   return($c,$d,$n,$s);
}

sub topic_u{
   print $sock "/UCTOPIC $_[0]\n";
   chomp(my $tmp=<$sock>);
   return $tmp
}

sub send_u{
   my $send=shift;
   print $sock $send,"\n";
}

sub close_u{
   print $sock "/CLOSESOCKET\n";
   close($sock);
}

sub escapehtml{
   my $tmp=shift;
   $tmp =~ s/</&lt;/g;
   $tmp =~ s/>/&gt;/g;
   $tmp =~ s/"/&quot;/g;
   return $tmp;
}

sub stripcrap{
   my $text = shift;
   $text =~ s/\003(\d{1,2})(\,(\d{1,2})|)//gi;
   $text =~ s/(\001|\002|\003|\022|\037)//gi;
   return $text;
}

sub config{
   my $file=shift;
   my $section;
   # I wonder how you are 'supposed' to do this?
   no strict "refs";
   open(CONFIG, $file) or error("Unable to open config file");
   while(<CONFIG>){
	  s/(\015\012|\012)$//;
      next if /^(#|;)/;
      next if $_ !~ /^\S/;
      if(/^\[(\w+)\]$/){
         my $tmp=$1;
         $section= \%$tmp;
      }else{
         my($key,$value)=split(/=/,$_,2);
         $$section{$key}=$value;
      }
   }
   close(CONFIG);
}

sub loadformat{
   my $format = $q->param('style');
   if($format =~ /[^A-Za-z0-9-]/ || !-f "formats/".$format.".pl"){
	  require("formats/$config{format}.pl");
	  $config{style} = $config{format};
   }else{
	  require("formats/$format.pl");
	  $config{style} = $format;
   }
}

