# CGI:IRC format file
%formats = (
   'quit' => sub {
      my($remotenick,$remotehost,$reason) = @_;
	  prefixecho('enter','<tt><small>&lt;--</small></tt>');
	  html("$remotenick has quit ($reason)",$colours{enter});		 
   },
   'part' => sub {
      my($remotenick,$remotehost,$reason,$channel) = @_;
	  prefixecho('enter','<tt><small>&lt;--</small></tt>');
	  html("$remotenick $remotehost left $channel ($reason)", $colours{enter});    },
   'join' => sub {
      my($remotenick,$remotehost,$channels,$channel) = @_;
	  prefixecho('enter','<tt><small>--&gt;</small></tt>');
	  html("$remotenick $remotehost joined $channel",$colours{enter});
   },
   'nick-me' => sub {
      my($remotenick,$remotehost,$newnick) = @_;
	  prefixecho('enter');
	  html("You are now known as $newnick",$colours{enter});
   },
	'nick-others' => sub {
      my($remotenick,$remotehost,$newnick) = @_;
	  prefixecho('enter');
	  html("$remotenick is now known as $newnick",$colours{enter});
   },
   'kick' => sub {
      my($remotenick,$remotehost,$reason,$channel,$kicknick) = @_;
	  prefixecho('enter');
	  html("$remotenick kicked $kicknick on $channel: $reason", $colours{enter}); 
   },
   'notice-server' => sub {
      my($remotenick,$remotehost,$text,$channel) = @_;
	  prefixecho('server');
	  html($text);
   },
   'notice-channel' => sub {
      my($remotenick,$remotehost,$text,$channel) = @_;
	  prefix( htmlnick($remotenick, $channel, $text, 'ctcp') );
	  html($text,$colours{mesg});		   
   },
   'notice-private' => sub {
      my($remotenick,$remotehost,$text,$channel) = @_;
	  prefix( htmlnick($remotenick, $channel, $text, 'ctcp') );
	  html($text,$colours{mesg});
   },
   'notice-send' => sub {
   },
   'ctcp-reply' => sub {
	  my($remotenick,$remotehost,$ctcp_command,$ctcp_params)=@_;
	  prefixecho('ctcp');
	  html("CTCP $ctcp_command reply from $remotenick: $ctcp_params",$colours{ctcp});
   },
   'ctcp-send' => sub {
	  my($channel,$ctcpcmd,$text) = @_;
	  prefix("CTCP->$channel:");
	  html("$ctcpcmd $text",$colours{ctcp});
   },
   'ctcp-request' => sub {
	  my($remotenick,$type,$channel) = @_;
	  prefixecho('ctcp');
	  html("$remotenick requested CTCP $type from $channel",$colours{ctcp});
   },
   'ctcp-unknown' => sub {
	  my($remotenick,$channel,$type,$params) = @_;
	  prefixecho('ctcp');
	  html("$remotenick requested Unknown CTCP $type ($params) from $channel",$colours{ctcp});
   },
   'topic-text' => sub {
	  my($remotenick,$remotehost,$text,$channel) = @_;
	  prefixecho('channel');
	  html("topic $channel: $text");
   },
   'topic-change' => sub {
	  my($remotenick,$remotehost,$text,$channel)=@_;
	  prefixecho('channel');
	  html("$remotenick changed the topic of to: $text",$colours{channel});		
   },
   'topic-time' => sub {
	  my($remotenick,$remotehost,$text,$channel,$who,$time) = @_;
	  prefixecho('channel');
	  html("Set by $who on ".scalar localtime($time));
   },
   'mode-user' => sub {
	  my($remotenick,$remotehost,$mode,$channel)=@_;
	  prefixecho('channel');
	  html("Usermode/$channel $mode by $remotenick", $colours{client});
   },
   'mode-channel' => sub {
	  my($remotenick,$remotehost,$mode,$channel)=@_;
	  prefixecho('client');
	  html("Mode/$channel $mode by $remotenick", $colours{channel});
   },
   'mode-server' => sub {
	  my($remotenick,$remotehost,$mode,$channel)=@_;
	  prefixecho('channel');
	  html("ServerMode/$channel $mode by $remotenick", $colours{channel});
   },
   'invite' => sub {
	  my($remotenick,$remotehost,$channel) = @_;
	  prefixecho('channel');
	   html("$remotenick invites you to $channel, type /j $channel to join", $colours{channel});
   },
   'wallop' => sub {
	  my($remotenick,$remotehost,$text) = @_;
	  html("Wallop: $remotenick: $text");
   },
# eventually these will go
   'generic-info-param-text' => sub {
	  prefixecho();
	  html("$_[3]: $_[2]");
   },
   'generic-info-params-text' => sub {
	  prefixecho();
	  html("$_[3]:$_[3] $_[2]");
   },
   'generic-info-text' => sub {
	  prefixecho();
	  html($_[2]);
   },
# end
# servers
   'generic-server-text' => sub {
	  prefixecho('server');
	  html($_[2], $colours{server});
   },
   'generic-server-param-text' => sub {
	  prefixecho('server');
	  html("$_[3] $_[2]", $colours{server});
   },
   'generic-server-params' => sub {
	  prefixecho('server');
      html(join(" ",@_[3..scalar(@_)]), $colours{server});
   },
   'bans' => sub {
	  my($channel,$ban,$by,$time) = @_;
	  prefixecho('channel');
	  html("Ban $channel: $ban by $by," . scalar localtime $time);
   },
# end
   'nickname-inuse' => sub {
	  prefixecho('server');
	  html("$_[3]: Nickname is already in use");
   },
   'nickname-taken' => sub {
	  prefixecho('server');
	  html("$_[3]: Your nick is taken, type /nick <newnick> to use another");
   },
   'userhost' => sub {
	  prefixecho();
	  html("$_[0] is $_[1]");
   },
   'mode-numeric' => sub {
	  prefixecho('channel');
	  html("mode/$_[3] ".join(" ",@_[4..scalar(@_)]));
   },
   'mode-created' => sub {
	  prefixecho('channel');
	  html("Channel $_[3] created ".scalar localtime $_[4]);
   },
   'ison' => sub {
	  prefixecho();
	  html("Currently online: $_[2]");
   },
   'whois-hostname' => sub {
	  prefixecho();
	  html("$_[3] ($_[4]\@$_[5])");
	  prefixecho();
	  html("ircname: $_[2]");
   },
   'whois-server' => sub {
	  prefixecho();
	  html("server: $_[4] ($_[2])");
   },
   'whois-oper' => sub {
	  prefixecho();
	  html("operator: $_[3] ($_[2])");
   },
   'whois-was' => sub {
	  prefixecho();
	  html("was: $_[3]!$_[4]\@$_[5] ($_[2])");
   },
   'whois-idle' => sub {
	  prefixecho();
	  html("idle: $_[4] secs (signon: ".localtime($_[5]).")");
   },
   'whois-channels' => sub {
	  prefixecho();
	  html("channels: $_[2]");
   },
   'whois-other' => sub {
	  prefixecho();
	  html("       : $_[2]");
   },
   'who' => sub {
	  prefixecho();
	  html("$_[3] $_[8] $_[7]!$_[4]\@$_[5] $_[6] ($_[2])");
   },
   'list-begin' => sub {
	  prefixecho();
	  html("Channel List: Users: Topic");
   },
   'list' => sub {
	  prefixecho();
	  html("$_[3] $_[4] $_[2]");
   },
   'list-end' => sub { },
   'default-channel' => sub {
	  print "<p align=\"center\">----- $_[0] -----</p>\n";
	  
   },
   'msg-pub-me' => sub {
	  my ($channel, $remotenick, $text)=@_;
	  prefix( htmlnick( $remotenick, $channel, $text ) );
	  html( "$text\n" );
   },
   'msg-pub-other' => sub {
	  my ($channel, $remotenick, $text)=@_;
	  prefix( htmlnick( $remotenick, $channel, $text ) );
	  html( "$text\n" );
   },
   'msg-pub-action' => sub {
	  my($channel,$remotenick,$text) = @_;
	  prefix(htmlnick($remotenick, $channel, $text, 'action'));
	  html("$remotenick $text\n");
   },
   'msg-priv-to' => sub {
	  my ($remotenick, $text) = @_;
	  prefix(htmlnick($remotenick, $config{nick}, $text ));
	  html("$text\n" );
	  
   },
   'msg-priv-ato' => sub {
	  my($channel,$remotenick,$text) = @_;
	  prefix(htmlnick($remotenick, $channel, $text, 'action'));
	  html("$remotenick $text\n");
   },
   'msg-priv-from' => sub {
	  my ($remotenick, $text) = @_;
	  prefix(htmlnick($remotenick, $config{nick}, $text ));
	  html("$text\n" );
   },
   'msg-priv-afrom' => sub {
	  my($channel,$remotenick,$text) = @_;
	  prefix(htmlnick($remotenick, $channel, $text, 'action'));
	  html("$remotenick $text\n");
   },
);

%messages = (
   'error-socketexists' => 'Communication socket already exists',
   'error-cannotcreatesocket' => 'Unable to create UNIX domain socket: ',
   'error-unabletoopen' => 'Unable to open: ',
   'error-ipblocked' => "Your IP ($ENV{REMOTE_ADDR}) is blocked from accessing this program, please email the administator of the system if you feel this is incorrect",
   'error-referer' => "Your Referer ($ENV{HTTP_REFERER}) does not allow access to this program",
   'error-nicknameneeded' => 'You must specify a nick name',
   'error-randomvalue' => 'Random Value invaild',
   'error-unparseable' => 'Unparseable text from server:',
   'error-unknown' => 'Unknown text from server: ',
   'access-server' => sub {
	  return "sorry access to server $_[0] is denied";
   },
   'access-channel' => sub {
	  return "sorry access to channel $_[0] is denied";
   },
   'access-command' => sub {
	  return "command disabled";
   },
   'ignore-list' => 'Current ignore list: ',
   'ignore-provide' => 'Please provide a nickname to unignore',
   'ignoreisntbeing' => ' isn\'t being ignored',
   'ignore-ignored' => 'Ignored ',
   'ignore-unignored' => 'Unignored ',
   'query -start' => 'Starting query with ',
   'query-not' => ' is not a query',
   'query-end' => 'Ending query with ',
   'ctcpkill-error' => sub {
	  return "$_[0] tried to ctcp kill you for $_[1] but failed";
   },
   'ctcpkill' => sub {
	  return "$_[0] ctcp killed you for $_[1]";
   },
   'html-header' => sub {
	  my $cssfont;
	  if($config{monospaced}){
		 $cssfont = "Courier new, Courier, monospace;";
	  }else{
		 $cssfont = "Arial, Helvetica, sans-serif;";
	  }
	  print <<EOF;
<html><head>
<title>CGI:IRC $version</title>
<style><!--
body { word-wrap:break-word; font-family: $cssfont; }
a { text-decoration: none }
a:link { color: #00f; background: transparent none; }
a:visited { color: #800080; background: transparent none; }
a:hover { background: #8cadce none; color: #ffffff; }
a:active { background: #8cadce none; color: #ffffff; }
//-->
</style>
</head><body bgcolor="$colours{bgcolor}" text="$colours{text}"><p>
EOF
   },
   'footer' => sub {
	  prefixecho('client');
	  html("CGI:IRC $version (http://cgiirc.sourceforge.net/)",$colours{client});
	  print "</p></body></html>\n";
   },
   'form' => sub {
	   my($channel,$escaped_channel,$escaped_topic) = @_;
	   my $hiddenform;
	   if($config{hiddenform}){
		  $hiddenform = " target=\"hidden\"><input type=\"hidden\" name=\"action\" value=\"hidden\"";
	   }else{
		  $hiddenform = "";
	   }
	   print <<EOF;
<html><head>
<title>Form</title>
</head><body onload="document.myform.say.focus()" topmargin="0" leftmargin="0" bottommargin="0" rightmargin="0"  bgcolor="$colours{bgcolor}" background="$config{htmlpath}form-bg.gif" text="$colours{text}">
<table border="0" cellspacing="1" cellpadding="0"><tr><form>
<td width="120" align="Center" valign="bottom" height="30">
<input type="text" size="10" style="background-color: $colours{bgcolor}; font-weight: bold; color: $colours{text};" value="$config{nick}">
</td> <td align="Left" valign="bottom" height="30">
<font face="Arial" size="1">
<input type="text" size="50" value="$escaped_channel: $escaped_topic" style="background-color: $colours{bgcolor}; color: $colours{text};"></font></td></form><td align="left" valign="bottom" height="30"></td></tr><tr>
<td width="120" align="Center" valign="bottom" height="30"><form name="myform" action="$config{irc_form}" method="Post"$hiddenform><input type="hidden" name="chan-default" value="$escaped_channel"><input type="hidden" name="r" value="$rand"><input type="hidden" name="style" value="$config{style}"><input type="hidden" name="js" value="$config{js}">
<select name="c">
EOF
   printchannels($channel);
   print <<EOF;
</select></td><td align="left" valign="bottom" height="30">
<input type="text" name="say" size="50" style="background-color: #C0C0C0;" onkeydown="if(window.event)with(event){if(keyCode==66&&ctrlKey){this.value+='\%B';keyCode=0;returnValue=false}if(keyCode==67&&ctrlKey){this.value+='\%C';keyCode=0;returnValue=false}}" autocomplete="off">
</td><td align="left" valign="bottom" height="30"><input alt="Say" border="0" src="$config{htmlpath}button-say.gif" type="image" width="50" height="25"></td></form>
</tr><tr><td width="120" align="Center" valign="top" height="30"><font face="Arial" size="1">User IP Address<br>$ENV{'REMOTE_ADDR'}</font></td>
<td align="Left" valign="top" height="30"><table border="0" cellpadding="0" cellspacing="1"><tr><td></td><td><a href="$config{irc_form}?r=$rand\&say=/part%20$channel" onclick="return confirm('Are you sure you want to leave this channel?')"><img alt="Leave Channel" border="0" src="$config{htmlpath}button-part.gif" width="75" height="20" align="top" ></a>
</td><td>
<a href="$config{irc_form}?r=$rand\&say=/quit" onclick="return confirm('Are you sure you want to quit?')"><img alt="Quit IRC" border="0" src="$config{htmlpath}button-quit.gif" width="75" height="20" align="top"></a>
</td></tr></table></form></td><td align="left" valign="top" height="30"></td></tr></table></body></html>
EOF
   },
   'userlist' => sub {
	  my($channel,$escapedchannel) = @_;
	  print <<EOF;
<html><head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<noscript><meta http-equiv="Refresh" content="35;URL=$config{irc_userlist}?r=$rand"></noscript><title>Userlist for $escapedchannel</title>
<script language="JavaScript"><!--
function OpenWindowABT(sURL){
   window.open(sURL,"ABT","left=22,top=22,toolbar=no,directories=no,width=360,height=150") } 
function OpenWindowHLP(sURL){
   window.open(sURL,"HLP","left=22,top=22,toolbar=no,directories=no,width=200,height=450") } 
//-->
</script></head><body bgcolor="$colours{bgcolor}" text="$colours{text}" topmargin="2"><div align="center"><center><table border="0" cellspacing="0" cellpadding="0" height="100%"><tr><td width="100%" valign="top" align="center" height="70"><img border="0" src="$config{htmlpath}$config{image}" width="85" height="64"></td></tr><tr><td width="100%" valign="top" align="left"><form action="$config{irc_userlist}" method="post"><p><B>$escapedchannel</b><br>
<input type="hidden" name="r" value="$rand"><input type="hidden" name="style" value="$config{style}">
EOF
printlist($channel);
print <<EOF;
<br><select name="action"><option value="whois" selected>Whois</option><option value="query">Query</option><option value="ping">Ping</option><option value="op">Op</option><option value="voice">Voice</option><option value="deop">Deop</option><option value="devoice">Devoice</option><option value="kick">Kick</option><option value="ban">Ban</option></select>
<input alt="Do" border="0" src="$config{htmlpath}button-do.gif" type="image" width="30" height="20" align="top"></p>
</form>
</td></tr><tr><td valign="bottom" align="center"><a href="irc.cgi" target="_top" onclick="return confirm('This will leave CGI:IRC, are you sure?')"><img border="0" src="$config{htmlpath}button-main.gif" width="100" height="20" alt="Main Connections Menu"><br> </a><a href="#" onclick="OpenWindowHLP('$config{htmlpath}help.html')"><img border="0" src="$config{htmlpath}button-command.gif" alt="CGI:IRC Commands" width="100" height="20"><br> </a><a href="#" onclick="OpenWindowABT('$config{htmlpath}about.html')"><img border="0" src="$config{htmlpath}button-about.gif" width="100" height="20" alt="About CGI:IRC"></a><br>
<font face="Arial" size="1"></tr></table></center></div></body></html>
EOF
   },
);

%symbols = (
   'sep' => ':',
   'ctcp-right' => '*',
   'ctcp-left' => '*',
   'action-left' => '',
   'action-right' => '',
   'channel-left' => '&lt;',
   'channel-right' => '&gt;',
   'other-left' => '-',
   'other-right' => '-',
   'action' => '*',
   'nick-left' => '<b>',
   'nick-right' => '</b>',
);

%colours = (
   '0' => '#FFFFFF',
   '1' => '#000000',
   '2' => '#0000FF',
   '3' => '#008000',
   '4' => '#FF0000',
   '5' => '#800000',
   '6' => '#800080',
   '7' => '#FF6600',
   '8' => '#FFFF00',
   '9' => '#00FF00',
   '00' => '#FFFFFF',
   '01' => '#000000',
   '02' => '#0000FF',
   '03' => '#008000',
   '04' => '#FF0000',
   '05' => '#800000',
   '06' => '#800080',
   '07' => '#FF6600',
   '08' => '#FFFF00',
   '09' => '#00FF00',
   '10' => '#008080',
   '11' => '#00FFFF',
   '12' => '#0000FF',
   '13' => '#FF00FF',
   '14' => '#808080',
   '15' => '#C0C0C0',
   'bgcolor' => '#ffffff',
   'text' => '#000000',
   'client' => '#0000ff',
   'enter' => '#0000ff',
   'channel' => '#0000ff',
   'server' => '#ff0000',
   'mesg' => '#ff0000',
   'action' => '#999900',
   'ctcp' => '#00ff00',
   'link' => '#0000ff',
   'empubl' => '#000000',
   'empublbg' => '#ffff00',
   'publbracket' => '#000ff0',
   'pubhbracket' => '#ff0000',
   'publbg' => '#ffffff',
   'publ' => '#000000',
   'hilight' => '#8cadce',
   'hilight2' => '#ffffff',
);
$config{echo_string} = "<tt><small>***</small></tt>";
$config{scroll} = "window.scrollBy(0,2000)";
$config{formheight} = "110";

sub htmlnick {
    my( $remotenick, $channel,  $text, $type ) = @_;

    my $middle;
    my( $left, $right );
	
    if( $type eq 'ctcp' ) {
       $left = $symbols{'ctcp-left'};
       $right = $symbols{'ctcp-right'};
	} elsif( $type eq 'action'){
	   $left = $symbols{'action-left'};
	   $right = $symbols{'action-right'};
    } elsif( is_channel( $channel ) ) {
       $left = $symbols{'channel-left'};
       $right = $symbols{'channel-right'};
    } else {
	   $left = $symbols{'other-left'};
	   $right = $symbols{'other-right'};
    }

    if( $type eq 'action' ) {
	   if( lc($channel) eq lc($default_channel) ) {
        $middle = colour($symbols{'action'}, $colours{'action'});
	   } else {
        $middle = colour($symbols{'action'} . $symbols{'sep'} . $channel, $colours{'action'});
	   }
    } else {
	   if( lc($channel) eq lc($default_channel) ) {
		  $middle = escapehtml($remotenick);
	   } else {
		  $middle = escapehtml($remotenick) . $symbols{'sep'} . $channel;
	   }
	}

    if( $remotenick eq $nick ) {
       $left = colour($symbols{'nick-left'}.$left.$symbols{'nick-right'},$colours{'publbracket'});
       $right = colour($symbols{'nick-left'}.$right.$symbols{'nick-right'}, $colours{'publbracket'});
    } else {
       $left = colour($symbols{'nick-left'}.$left.$symbols{'nick-right'}, $colours{'pubhbracket'});
       $right = colour($symbols{'nick-left'}.$right.$symbols{'nick-right'}, $colours{'pubhbracket'});
    }

    my $prefix = $left . $middle . $right;

    if($text =~ /^\Q$nick\E[^a-z0-9]/i) {
       return colour($prefix, $colours{hilight2}, $colours{hilight});
    } else {
	   return $prefix;
    }
}

sub prefix {
    my( $prefix ) = @_;
	return if defined $config{hidelogin} and $config{hidelogin};

	if($config{timestamps}){
	   my ($sec,$min,$hour) = localtime(time);
	   $min = "0" . $min if length $min == 1;
	   $hour = "0" . $hour if length $hour == 1;
	   $prefix = "[$hour:$min] ".$prefix;
	}
	
	if($config{margin}) {
	   my $text = $prefix;
	   $text =~ s/<.*?>//g;
	   $text =~ s/&.*?;/-/g;
	   my $padno = (16-length($text));
	   $padno = 0 if $padno < 0;
	   my $pad = "&nbsp;"x$padno;
	}
	print "$prefix\n";
}

sub prefixecho {
    my( $type, $text ) = @_;
    my $colour = $colours{$type||'client'};
    $text ||= $config{echo_string};
    prefix( colour( $text, $colour ));
}

1;
