#!/usr/bin/perl
# cgi-irc v0.4.2 - http://cgiirc.sourceforge.net/
# (C) 1999-2000 David Leadbeater (cgiirc@dgl.cx)
# cgi-irc comes with ABSOLUTELY NO WARRANTY
# This is free software, and you are welcome to redistribute it
# under certain conditions; read the file COPYING for details

# This prints the form and the frameset, to load CGI:IRC.

#use strict;
my $version="0.4.2";
use vars qw(%config %styles %colours $channel $say $rand $sock);
use IO::Socket;
use CGI;

$config{file}="config";
&config($config{file});

my $q = new CGI;
loadformat();

if(!$q->param('myaction')){
   if($config{form_redirect}){
	  print $q->redirect($config{form_redirect});
	  exit;
   }else{
	  print "Cache-Control: no-cache\nExpires: -1\nPragma: no-cache\nContent-type: text/html\n\n";
   }
   &check_referer if($config{referer} eq 2);
   $config{default_nick} =~ s/\?/int(rand(9))/eg;
   print <<EOF;
<html><head>
<title>CGI IRC - Login</title>
</head><body bgcolor="$colours{bgcolor}" text="$colours{text}">
<p align="center"><a href="http://cgiirc.sourceforge.net/"><img src="$config{htmlpath}$config{image}" border=0></a><br>Release $version</p>
<form method="post" action="irc.cgi" name="irc">
<input type="hidden" name="myaction" value="load">
<table border=0>
<tr><td><b>Server</b></td><td><input type="text" name="s" value="$config{default_server}"></td></tr>
<tr><td><b>Port:</b></td><td><input type="text" name="p" value="$config{default_port}"></td></tr>
EOF
print "<tr><td><b>Password:</b></td><td><input type=\"text\" name=\"sp\"></td></tr>\n" if $config{passwords};
print <<EOF;
<tr><td><b>Nick:</b></td><td><input type="text" name="n" value="$config{default_nick}"></td></tr>
<tr><td><b>Realname:</b></td><td><input type="text" name="l" value="$config{default_name}"></td></tr>
<tr><td><b>Channels</b></td><td><input type="text" name="c" value="$config{default_channels}"></td></tr>
<tr><td><b>Format:</b></td><td><select name="style">
EOF
opendir(FORMATS, "formats/") or error($!);
for(readdir(FORMATS)){
   next if /^\./;
   s/\.pl$//;
   if($_ eq $config{format}){
	  print "<option value=\"$_\" selected=1>$_</option>\n";
   }else{
	  print "<option value=\"$_\">$_</option>\n";
   }
}
closedir(FORMATS);
print <<EOF;
</select></td></tr>
<tr><td><b>Userlist:</b></td><td><input type="checkbox" name="u" value="yes" CHECKED=1></td></tr>
<tr><td>&nbsp;</td><td>
<input type="hidden" name="js" value="0">
<script><!--
document.irc.js.value="1";
//-->
</script>
<input type="submit" value=" Login "></td></tr>
</table>
</form>
<br>
<a href="$config{htmlpath}docs.html">Documentation</a>
</body></html>
EOF
}elsif($q->param('myaction') eq "load"){
   print "Cache-Control: no-cache\nExpires: -1\nPragma: no-cache\nContent-type: text/html\n\n";
   &check_referer if $config{referer};
   $rand=rand_text(12);
   until(!-e $config{tmpfile_prefix}.$rand){$rand=rand_text(12)}
   my $tmp=$q->param('n');
   print <<EOF;
<html>
   <head>
   <title>CGI IRC - $tmp</title>
   </head>
EOF

if($q->param('u')){
   print "<frameset cols=\"*,150\" framespacing=\"0\" border=\"0\" frameborder=\"0\">";
}

if($q->param('js') and $config{hiddenform}){
   print "<frameset rows=\"*,0,$config{formheight}\" framespacing=\"0\" border=\"0\" frameborder=\"0\">";
}else{
   print "<frameset rows=\"*,$config{formheight}\" framespacing=\"0\" border=\"0\" frameborder=\"0\">";
}

my $onreadyurl = "irc.cgi";
if($config{form_redirect}){
   $onreadyurl = $config{form_redirect}
}
   
print("<frame onreadystatechange=\"if(this.readyState=='complete')top.location='$onreadyurl'\" name=\"irc\" src=\"$config{irc_script}?r=$rand&s=",$q->escape($q->param('s')),
  "&p=",$q->escape($q->param('p')),
    "&n=",$q->escape($q->param('n')),
	  "&l=",$q->escape($q->param('l')),
	    "&c=",$q->escape($q->param('c')),
		  "&style=",$q->escape($q->param('style')),
			"&sp=", $q->escape($q->param('sp')),
			 "&js=", $q->escape($q->param('js')),
			  "&u=",$q->param('u'),"\">");

print "<frame name=\"hidden\" src=\"$config{irc_form}?r=$rand&action=hidden\">" if $q->param('js') and $config{hiddenform};
print "<frame name=\"form\" src=\"$config{irc_form}?r=$rand&action=form&s=",
  $q->escape($q->param('s')),
    "&p=",$q->escape($q->param('p')),
	  "&n=",$q->escape($q->param('n')),
	   "&first=11",
	    "&l=",$q->escape($q->param('l')),
		  "&c=",$q->escape($q->param('c')),
			"&js=", $q->escape($q->param('js')),
		    "&style=",$q->escape($q->param('style')),"\">";
print "</frameset><frame name=\"userlist\" src=\"$config{irc_userlist}?r=$rand\&first=11\&m=",$q->escape($q->param('m')),"\">" if $q->param('u');
print <<EOF;
<noframes>
   <body>
   Sorry this script cannot be used without frames, please get a frames complatable browser like <a href="http://www.netscape.com/">Netscape</a>, <a href="http://www.mozilla.org/">Mozilla</a> or <a href="http://www.microsoft.com/ie/">Internet Explorer</a><br>
   </body>
</noframes>
</frameset>
</html>
EOF
}else{
   print $q->header();
   print "<html><body>Error unknown action</body></html>";
}

sub rand_text{
   my $num=shift;
   my ($lid,$i);
   my @rand=('a'..'z', '0'..'9');
   for($i=0;$i < $num;$i++){$lid.=$rand[rand()*($#rand+1)]}
   return($lid);
}

sub config{
   my $file=shift;
   my $section;
   # I wonder how you are 'supposed' to do this?
   no strict "refs";
   open(CONFIG, $file) or error("Unable to open config file: $!");
   while(<CONFIG>){
	  s/(\015\012|\012)$//;
      next if /^(#|;)/;
      next if $_ !~ /^\S/;
      if(/^\[(\w+)\]$/){
         my $tmp=$1;
         $section= \%$tmp;
      }else{
         my($key,$value)=split(/=/,$_,2);
         $$section{$key}=$value;
      }
   }
   close(CONFIG);
}

sub check_referer{
   return 0 if !$ENV{HTTP_REFERER} or !$ENV{SERVER_NAME};
   if($ENV{HTTP_REFERER} !~ /^http:\/\/\Q$ENV{SERVER_NAME}\E/i){
	  print "<html><body>Access Denied: Bad Referer</body></html>\n";
	  exit;
   }
}

sub loadformat{
   my $format = $q->param('style');
   if($format =~ /[^A-Za-z0-9-]/ || !-f "formats/".$format.".pl"){
	  require("formats/$config{format}.pl") or error("Unable to load format: $! $@");
	  $config{style} = $config{format};
   }else{
	  require("formats/$format.pl") or error("Unable to load format: $! $@");
	  $config{style} = $format;
   }
}

sub error{
   print "Content-type: text/html\n\n$_[0]\n";
   exit(0);
}

