#!/usr/bin/perl
# CGI:IRC  0.4.2 - http://cgiirc.sourceforge.net/
# (C) 2000-2001 David Leadbeater (cgiirc@dgl.cx)
# CGI:IRC comes with ABSOLUTELY NO WARRANTY
# This is free software, and you are welcome to redistribute it
# under certain conditions; read the file COPYING for details

# This deals with the userlist, it takes the users over the unix-domain socket 
# and prints a nice form for the user to do stuff with the users, which it
# sends back to nph-irc.cgi over the unix-domain socket

use strict;
my $version="0.4.2";
use vars qw/%colours %formats %messages %symbols/;
use vars qw/%config %irc %names/;
use vars qw/$channel $say $rand $sock $channel/;
use IO::Socket;
use CGI;
my $q = new CGI;
print "Cache-Control: no-cache\nExpires: -1\nPragma: no-cache\nContent-type: text/html\n\n";

# Change this if you change the location of the config file
$config{file}="config";
config($config{file});
loadformat();
$rand=$q->param('r');
$rand=~ s/[^a-z,0-9]//g;

if(my $action=$q->param('action')){
   connect_u($rand) or error();
   if($action eq "whois"){
	  my $user=$q->param('user');
	  $user =~ s/^(\@|\+)//;
	  &send_u("/whois ".$user."\n");
   }
   elsif($action eq "ping"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/ping ".$user."\n");
   }
   elsif($action eq "op"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/op ".$user."\n");
   }
   elsif($action eq "voice"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/voice ".$user."\n");
   }
   elsif($action eq "deop"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/deop ".$user."\n");
   }
   elsif($action eq "devoice"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/devoice ".$user."\n");
   }
   elsif($action eq "kick"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/kick ".$user."\n");
   }
   elsif($action eq "ban"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/ban ".$user."\n");
   }
   elsif($action eq "query"){
          my $user=$q->param('user');
          $user =~ s/^(\@|\+)//;
          &send_u("/query ".$user."\n");
   }
}
&main;

sub main{
   if(!defined $sock){
	  connect_u($rand) or error();
   }
   my ($dummy,$channel) = status_u();
   &{$messages{'userlist'}}($channel,escapehtml($channel));
   close_u();
}

sub printlist{
   my $channel = shift;
   my @userlist=userlist($channel);
   %names = nameslist_u($channel);
   @userlist=sort {uc($a) cmp uc($b)} @userlist;
   if($config{userstyle} eq "select"){
	  my $width = 13;
	  my $pad = "";
	  print "<SELECT name=\"user\" SIZE=\"9\">\n";
	  for(@userlist){
		 if(/^\@/){
			length($_) < $width ? $pad = "&nbsp;"x($width-length($_)) : "";
			print "<option value=\"$_\"".makestatuschange($_).">$_$pad</option>\n";
		 }
	  }
	  for(@userlist){
		 if(/^\%/){
			length($_) < $width ? $pad = "&nbsp;"x($width-length($_)) : "";
			print "<option value=\"$_\"".makestatuschange($_).">$_$pad</option>\n";
		 }
	  }
	  for(@userlist){
		 if(/^\+/){
			length($_) < $width ? $pad = "&nbsp;"x($width-length($_)) : "";
			print "<option value=\"$_\"".makestatuschange($_).">$_$pad</option>\n";
		 }
	  }
	  for(@userlist){
		 if($_ !~ /^[\@\%\+]/){
			length($_) < $width ? $pad = "&nbsp;"x($width-length($_)) : "";
			print "<option value=\"$_\"".makestatuschange($_).">$_$pad</option>\n";
		 }
	  }
	  print "</select>\n";
   }else{
	  for(@userlist){
		 if(/^\@/){
			print "<input type=\"radio\" name=\"user\" ".makestatuschange($_)."value=\"$_\">$_<br>\n";
		 }
	  }
	  for(@userlist){
		 if(/^\%/){
			print "<input type=\"radio\" name=\"user\" ".makestatuschange($_)."value=\"$_\">$_<br>\n";
		 }
	  }
	  for(@userlist){
		 if(/^\+/){
			print "<input type=\"radio\" name=\"user\" ".makestatuschange($_)."value=\"$_\">$_<br>\n";
		 }
	  }
	  for(@userlist){
		 if($_ !~ /^[\@\%\+]/){
			print "<input type=\"radio\" name=\"user\" ".makestatuschange($_)."value=\"$_\">$_<br>\n";
		 }
	  }
   }
}

sub makestatuschange{
   my $user = shift;
   $user =~ s/^[\@\+\%]//;
   return "onmouseover=\"window.status='".escapehtml($names{$user})."'\" onmouseout=\"window.status=''\" ";
}

sub error{
   my $error=shift;
   if($q->param('first')){
	  print "<html><head><noscript><meta http-equiv=\"Refresh\" content=\"5;URL=$config{irc_userlist}?r=$rand\&anticache=".rand()."\"></noscript></head><body bgcolor=\"$colours{bgcolor}\" text=\"$colours{text}\">Loading...<br> Please wait</body></html>\n";
   }else{
	  print "<html><head><noscript><meta http-equiv=\"Refresh\" content=\"5;URL=$config{irc_userlist}?r=$rand\&anticache=".rand()."\"></noscript></head><body bgcolor=\"$colours{bgcolor}\" text=\"$colours{text}\"><a href=\"irc.cgi\" target=\"_top\">Login again?</a></body></html>\n";
   }
   exit;
}

sub escapehtml{
   my $tmp=shift;
   $tmp =~ s/</&lt;/g;
   $tmp =~ s/>/&gt;/g;
   $tmp =~ s/"/&quot;/g;
   return $tmp;
}

sub connect_u{
   my $random=shift;
   $sock = IO::Socket::UNIX->new(
      Peer => "$config{tmpfile_prefix}$random") or return undef;
}

sub userlist{
   $channel=shift;
   print $sock "/CHANNELUSERLIST $channel\n";
   chomp(my $tmp=<$sock>);
   return 0 if $tmp eq 1;
   return split(/ /, $tmp);
}

sub stripcrap{
   my $text = shift;
   $text =~ s/\003(\d{1,2})(\,(\d{1,2})|)//gi;
   $text =~ s/(\001|\002|\003|\022|\037)//gi;
   return $text;
}

sub nameslist_u{
   my $channel = shift;
   my %names;
   print $sock "/UCHOSTSNAMES $channel\n";
   while(<$sock>){
      chomp;
      last if $_ eq "END";
      my($tnick,$thost,$tname) = split(/ /,$_,3);
	  $tname =~ s/^://;
      $names{$tnick}=quotemeta(stripcrap("$thost ($tname)"));
   }
   return %names;
}

sub status_u{
   print $sock "/STATUS\n";
   my($c,$d,$n,$s);
   $c=<$sock>;
   $d=<$sock>;
   $n=<$sock>;
   $s=<$sock>;
   chomp($c,$d,$n,$s);
   return($c,$d,$n,$s);
}

sub send_u{
   my $send=shift;
   syswrite($sock,$send,length $send);
}

sub close_u{
   print $sock "/CLOSESOCKET\n";
}

sub config{
   my $file=shift;
   my $section;
   # I wonder how you are 'supposed' to do this?
   no strict "refs";
   open(CONFIG, $file) or die("Unable to open config file");
   while(<CONFIG>){
	  s/(\015\012|\012)$//;
      next if /^(#|;)/;
      next if $_ !~ /^\S/;
      if(/^\[(\w+)\]$/){
         my $tmp=$1;
         $section= \%$tmp;
      }else{
         my($key,$value)=split(/=/,$_,2);
         $$section{$key}=$value;
      }
   }
   close(CONFIG);
}

sub loadformat{
   my $format = $q->param('style');
   if($format =~ /[^A-Za-z0-9-]/ || !-f "formats/".$format.".pl"){
	  require("formats/$config{format}.pl");
	  $config{style} = $config{format};
   }else{
	  $config{style} = $format;
	  require("formats/$format.pl");
   }
}

