#!/usr/bin/perl
# David Leadbeater -- for CGI:IRC and a server with sethost/chghost
# dgl@dgl.cx -- http://cgiirc.sourceforge.net/

# Add this line into the irc_connect_ok subroutine of CGI:IRC, below the
# $config{connected}=1; line (it's about line number 600)
# HostServ is the nickname and cgiirchost is the password
# irc_server_raw("PRIVMSG", "HostServ :cgiirchost $ENV{REMOTE_ADDR}");

use IO::Socket;
$|=1;

my $nick="HostServ";
my $name="CGI:IRC HostServ";
my $server="dgl.yi.org";
my $port=6667;
# Command to oper with probally, user :password
my $oper="hostserv :password";
# Password for CGI:IRC to send to change the hostname
my $pass="cgiirchost";
# Command to send to server to change hostname
my $hostcommand="SETHOST";
# hostname the bot uses
my $hostname="services.dgl.yi.org";
# Level to log
my $loglevel=2;
# Reconnect time (don't put below the ping time of your server or you will be
# randomly disconnected)
my $reconnect=200;

sub connect_to_server{
    logmessages("Trying to connect to " . $server . " on port " . $port ,2);

    $remote = IO::Socket::INET->new(
		        Proto     => "tcp",
				PeerAddr  => $server,
				PeerPort  => $port,
	);
    unless ($remote) { 
	   logmessages("ERROR: Cannot connect to $server",1); 
	   return 
	}
    $remote->autoflush(1);

    irc_server_raw("NICK", "$nick");
    irc_server_raw("USER", "$nick $nick $nick :$name");
    logmessages("Connected to $server" ,2);
	$connected=1;
}

sub logmessages{
   my($message, $level) = @_;
   print $message."\n" if $level <= $loglevel;
}

sub irc_server_poll{
	irc_check_command(<$remote>); 
}


sub irc_check_command {
    my $response = shift;
    chomp $response;
	alarm($reconnect);

    my($immediate, $svrmsg, @tl) = split ":", $response;

    my $text = join ":", @tl;
    $text =~ s/[\n\r]//g;

    if ("PING" eq substr $immediate, 0, 4) {
	   irc_server_raw("PONG", "$svrmsg");
	   logmessages("SERVER PING",3);
	} elsif("ERROR" eq substr $immediate, 0, 5) {
	   close($remote);
    } else {
	   my @bits = split " ", $svrmsg;
	   my $remote_nick = (split "!", $svrmsg)[0];
	   my $remote_host = (split "!", $bits[0])[1];

	   if ($bits[1] eq "PRIVMSG"){
		  my $msg_channel = lc $bits[2];
		  if ($msg_channel eq lc $nick) {
			 my($spass,$shost)=split(/ /,$text);
			 return if $spass ne $pass;
			 irc_server_raw($hostcommand,"$remote_nick $shost");
		  }
	   }elsif($bits[1] eq '004'){
		  irc_server_raw("MODE","$nick +i");
		  irc_server_raw("OPER", $oper);
		  irc_server_raw($hostcommand, "$nick $hostname") if $hostname;
	   }
	}
}


sub irc_server_raw {
    alarm($reconnect);
    print $remote "$_[0] $_[1]\n"; 
}

while(1){
   connect_to_server;
   eval{
	  local $SIG{ALRM} = sub { die "disconnected" };
	  while(<$remote>){
		 irc_check_command($_);
	  }
   };
   if(!$connected){
	  sleep 10;
   }else{
	  $connected=0;
   }					 
}

